unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, System.Math, System.Varcmplx;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Edit_c: TLabeledEdit;
    Edit_b: TLabeledEdit;
    Edit_d: TLabeledEdit;
    Edit_a: TLabeledEdit;
    Button1: TButton;
    Label1: TLabel;
    Edit_e: TLabeledEdit;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    function datainput(var a, b, c, d, e: double): boolean;
    function quartic_equation_c(a, b, c, d, e: double; var x: array of double): byte;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// ʏ
//------------------------------------------------------------
// f̍\
type
  TCans = record
    n: integer;
    ans: array[0..3] of Variant;
  end;

// f real=0  Imaginary=0 ̍쐬
var
  Czero : Variant;

// f̐
function Varcomplex(a, b: double): Variant;
begin
  result := varascomplex(result);
  result.real := a;
  result.Imaginary := b;
end;

// f̃[ x=0 true  x<> 0 false
function cis0(x: Variant): boolean;
begin
  result := false;
  if (x.real = 0) and (x.Imaginary = 0) then result := true;
end;

// f̕
function csqrt(x: Variant): Variant;
var
  len: double;
begin
  result := Varascomplex(result);
  if x.Imaginary = 0 then begin
    if x.real >= 0 then result := VarComplex(sqrt(x.real), 0)
                   else result := VarComplex(0.0, sqrt(-x.real));
  end
  else begin
    len := sqrt(x.real * x.real + x.Imaginary * x.Imaginary);
    result.real := sqrt((len + x.real) / 2);
    result.Imaginary := sqrt((len - x.real) / 2);
    if x.Imaginary < 0 then result.Imaginary := -result.Imaginary;
  end;
end;

// 
function cbrt(x: double): double;
begin
  result := power(abs(x), 1/3);
  if x < 0 then result := -result;
end;

// f̗
function ccbrt(x: Variant): Variant;
var
  len, theta: double;
begin
  result := VarasComplex(result);
  if x.Imaginary = 0 then begin
    result := VarComplex(cbrt(x.real), 0);
    exit;
  end;
  len := cbrt(sqrt(x.real * x.real + x.Imaginary * x.Imaginary));
  theta := arctan2(x.Imaginary, x.real) / 3;
  result.real := len * cos(theta);
  result.Imaginary := len * sin(theta);
end;

// fꎟ̉@
function cequation1(a, b: Variant): TCans;
var
  i : integer;
begin
  for i := 0 to 3 do
    result.ans[i] := Czero;
  if cis0(a) then begin
    if cis0(b) then result.n := -1
               else result.n := 0;
  end
  else begin
    result.n := 1;
    result.ans[0] := -b / a;
  end;
end;

// f񎟎̉@
function cequation2(a, b, c: Variant): TCans;
var
  i : integer;
begin
  for i := 0 to 3 do
    result.ans[i] := Czero;
  if cis0(a) then begin
    result := cequation1(b, c);               // fꎟ
    exit;
  end;
  b := (VarComplex(-1 / 2, 0) * b) / a;
  c := c / a;
  a := csqrt((b * b) - c);                    // f
  result.ans[0] := b + a;
  result.ans[1] := b - a;
  result.n := 2;
end;

// Ỏ@
function equation3(a, b, c, d: double): TCans;
var
  w, w2, cA3, cm, cn      : Variant;
  A0, B0, C0, A3          : double;
  p, q, p3, q2, m, n      : double;
begin
  if a = 0 then begin
    w := VarComplex(b, 0);
    w2 := VarComplex(c, 0);
    cm := VarComplex(d, 0);
    result := cequation2(w, w2, cm);               // f񎟎̉@
    exit;
  end;
  A0 := b / a;
  B0 := c / a;
  C0 := d / a;

  w  := VarComplex(-1 / 2, sqrt(3) /  2);         // f1̎O捪   = (-1/2,  1/23i)
  w2 := VarComplex(-1 / 2, sqrt(3) / -2);         // f1̎O捪 2 = (-1/2, -1/23i)
  A3 := A0 / 3;                                   // x = y-a/3   y3 + p y + q = 0
  cA3 := VarComplex(A3, 0);
  p := B0 - A0 * A3;
  q := 2 * A3 * A3 * A3 - A3 * B0 + C0;
  p3 := p / 3;
  q2 := -q / 2;
  d := q2 * q2 + p3 * p3 * p3;                  // ʒl [g̒̌vZ   q^2 + 4p^3
  if d >= 0 then begin                          // d }CiXŖ  Sċ = 0
    m := cbrt(q2 + sqrt(d));                    //       (q2 + d)^1/3
    n := cbrt(q2 - sqrt(d));                    //       (q2 - d)^1/3
    result.ans[0] := VarComplex(m + n - A3, 0);                               // f x = (y-a/3, 0i)
    result.ans[1] := VarComplex(m, 0) * w  + VarComplex(n, 0) * w2 - cA3;     // f x = y - Ca/3
    result.ans[2] := VarComplex(m, 0) * w2 + VarComplex(n, 0) * w  - cA3;     // f x = y - Ca/3
  end
  else begin
    d := sqrt(abs(d));                          // d}CiX ldi
    cm := ccbrt(VarComplex(q2, d));             // f     (q2, di)^1/3
    cn := ccbrt(VarComplex(q2, -d));            // f     (q2,-di)^1/3
    result.ans[0] := cm + cn - cA3;             // ans[0]    = 0     f  x = y - Ca/3
    result.ans[1] := cm * w + cn * w2 - cA3;    // ans[1]    <> 0    f  x = y - Ca/3
    result.ans[2] := cm * w2 + cn * w - cA3;    // ans[2]    <> 0    f  x = y - Ca/3
  end;
  result.n := 3;
end;

// l̉@
//  X^4 + AX^2 + BX + C = 0
function equation4_sub(A0, B0, C0: double): TCans;
var
  res    : TCans;
  x1, x2 : Variant;
  Y, b1, c1, b2, c2: Variant;
  L, M, N        : double;
  res1, res2  : TCans;
  B, C, D     : double;
begin
  if B0 = 0 then begin                  // B0 = 0
    Y := VarComplex(1, 0);
    b1 := VarComplex(A0, 0);
    c1 := VarComplex(C0, 0);
    res := cequation2( Y, b1, c1);          // X^2 = y f 񎟎̉@ y^2 + A0y + C0
    x1 := csqrt(res.ans[0]);                // x = y
    x2 := csqrt(res.ans[1]);
    res.ans[0] := x1;
    res.ans[1] := -x1;
    res.ans[2] := x2;
    res.ans[3] := -x2;
    res.n := 4;
    result:= res;
  end
  else begin                            // B0 <> 0
    B := -A0 ;                                            //  X^4 = -AX^2 - BX - C  = 0 ӂ X^2L + L^2/4  Z ό`
    C := 4 * -C0;                                         // O@(L^3 - AL^2 - 4ACL + 4AC- B^2) o
    D := 4 * A0 * C0 - B0 * B0;                           // O L^3 - AL^2 - 4ACL + 4AC- B^2 = 0
    res1 := equation3( 1, B, C, D);                       // O@(1, -A, -4C, 4AC - B^2)
                                                          //  @ -------------------------
    L := res1.ans[0].real;                                    // L
    M := A0 -  L;                                             // M = A0 - L
    N := B0 / (2 * M);                                        // N = B0 / 2M
    Y := csqrt(VarComplex(-M, 0));                            // Y = (-M, 0i)      -M = L-A0
    b1 := -Y;                                                 // b1 = -Y
    c1 := VarComplex(L / 2, 0) - Y * VarComplex(N, 0);        // c1 = (L / 2, 0i) - Y(N, 0i)
    b2 := Y;                                                  // b2 = Y
    c2 := VarComplex(L / 2, 0) + Y * VarComplex(N, 0);        // c2 = (L / 2, 0i) + Y(N, 0i);

    res1 := cequation2(VarComplex(1, 0), b1, c1);             // y = X  f (!, 0i)y^2 + b1y + c1 = 0
    res2 := cequation2(VarComplex(1, 0), b2, c2);             // y = X  f (!, 0i)y^2 + b2y + c2 = 0
                                                          //----------------------------------------
    res1.ans[2] := res2.ans[0];
    res1.ans[3] := res2.ans[1];
    res1.n := 4;
    result := res1;
  end;
end;

//  l̉@@O捀x^3̏
function equation4sub(a, b, c, d: double): TCans;
var
  A0, B0, C0: double;
  aa : double;
  ca4 : Variant;
  res : TCans;
  i  : integer;
begin
  aa := a * a;
  ca4 := VarComplex(a / 4, 0);                                      // fCX = (a/4,0)
                                                                    // x = X - a/4     X^4 + A0X^2 + B0X + C0=0
  A0 := b - (3 / 8) * aa;
  B0 := c + a * aa / 8 - a * b / 2;
  C0 := d - (3 / 256) * aa * aa + aa * b / 16 - a * c / 4;

  res := equation4_sub(A0, B0, C0);
  for i := 0 to 3 do
    res.ans[i] := res.ans[i] - ca4;                                 // x = X - a/4
  result := res;
end;

// l̉@
function equation4(a, b, c, d, e: double): TCans;
begin
  if a = 0 then begin                                     // ax^4  a=0 ȂO@
    result := equation3(b, c, d, e);
    exit;
  end;
  result:= equation4sub(b / a, c / a, d / a, e / a);      // l@  x^4+b/ax^3+c/ax^2+d/ax+e/a = 0
end;

// ax^4 + bx^3 + cx^ + dx + e ̌vZ
function poly4(a, b, c, d, e: double; x: Variant): Variant;
var
  xx, xxx, xxxx : Variant;
  ar, br, cr, dr, er: Variant;
begin
  xx := x * x;
  xxx := xx * x;
  xxxx := xx * xx;
  ar := VarComplex(a, 0) * xxxx;
  br := VarComplex(b, 0) * xxx;
  cr := VarComplex(c, 0) * xx;
  dr := VarComplex(d, 0) * x;
  er := VarComplex(e, 0);
  result := ar + br + cr + dr + er;
end;

//--------------------------------------------------
// ꎟ񎟎Ol̉@
//--------------------------------------------------
function TForm1.quartic_equation_c(a, b, c, d, e: double;var x: array of double): byte;
const
  YY = 90;
var
  res       : TCans;
  j, k      : integer;
  rc        : Variant;
  i         : array[0..3] of double;
  rcr, rci  : array[0..3] of double;
  lng       : integer;
  tout      : string;

  function roundx(x: double):double;              // _10ȉۂ
  var
    ix  : int64;
    x10 : double;
  begin
    if abs(x) < 1E5 then begin
       x10 := x * 1E10;
       ix  := round(x10);
       result := ix / 1E10;
    end
    else result := x;
  end;

begin
  result := 0;
  res := equation4(a, b, c, d, e);
  for j := 0 to res.n - 1 do begin
    rc := poly4(a, b, c, d, e, res.ans[j]);
    x[j] := res.ans[j].real;
    i[j] := res.ans[j].Imaginary;
    rcr[j] := rc.real;
    rci[j] := rc.Imaginary;
  end;
  k := 1;
  if res.n > 0 then begin
    for j := 0 to res.n -1 do begin
      if i[j] = 0 then result := result or k;
      k := k * 2;
    end;

    with Memo1.Lines do begin
      if res.n = 4 then Add(' l̉@  f');
      if res.n = 3 then Add(' Ỏ@ʁ@f');
      if res.n = 2 then Add(' 񎟕̉@ʁ@f');
      if res.n = 1 then Add(' ꎟ̉@');
      Add('');
      if res.n > 0 then
        for j := 0 to res.n  - 1 do begin
          tout := (' x' + intTostr(j + 1) +  '= ' + floattostr(roundx(x[j])));
          lng := length(tout);
          for k := 0 to 22 - lng do tout := tout + ' ';
          tout := tout + floattostr(i[j]) + ' i';
          add(tout);
        end;
        Add('');
        Add('ans = aCx^4 + bCx^3 + cCx^ + dCx + e  fCxvZ');
        for j := 0 to res.n  - 1 do begin
          tout := ' ans' + intTostr(j + 1) + '= ' + floatTostr(roundx(rcr[j]));
          lng := length(tout);
          for k := 0 to 22 - lng do tout := tout + ' ';
          tout := tout + floatTostr(rci[j]) + ' i';
          add(tout);
        end;
    end;
  end;
end;

//-----------------------------------------------------------

function TForm1.datainput(var a, b, c, d, e: double): boolean;
var
  ch: integer;
begin
  result := false;
  val(edit_a.Text, a, ch);
  if ch <> 0 then begin
    application.MessageBox('̒lł͂܂B','', 0);
    exit;
  end;
  val(edit_b.Text, b, ch);
  if ch <> 0 then begin
    application.MessageBox('̒lł͂܂B','', 0);
    exit;
  end;
  val(edit_c.Text, c, ch);
  if ch <> 0 then begin
    application.MessageBox('̒lł͂܂B','', 0);
    exit;
  end;
  val(edit_d.Text, d, ch);
  if ch <> 0 then begin
    application.MessageBox('̒lł͂܂B','', 0);
    exit;
  end;
  val(edit_e.Text, e, ch);
  if ch <> 0 then begin
    application.MessageBox('̒lł͂܂B','', 0);
    exit;
  end;
  result := true;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  top := (screen.Height - height) div 2;
  left := (screen.Width - width) div 2;
  memo1.Font.Size := 12;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  a, b, c, d, e   : double;
  iflag           : byte;
  x               : array[0..3] of double;
  k, i            : integer;
  xans            : double;

  function roundx(x: double):double;                        // _10ȉۂ
  var
    ix  : int64;
    x10 : double;
  begin
    if abs(x) < 1E10 then begin
       x10 := x * 1E10;
       ix  := round(x10);
       result := ix / 1E10;
    end
    else result := x;
  end;

begin
  if not datainput(a, b, c, d, e) then exit;
  Memo1.Clear;
  iflag := quartic_equation_c(a, b, c, d, e, x);            // ̉@
  Memo1.Lines.Add('');

  Memo1.Lines.Add('ans = ax^4 + bx^3 + cx^ + dx + e      real xvZ');
  Memo1.Lines.Add('  iflag= ' + intTostr(iflag));
  k := 1;
  for i := 0 to 3 do begin
    if iflag and k = k then begin
      xans := a * x[i] * x[i] * x[i] * x[i]
            + b * x[i] * x[i] * x[i]
            + c * x[i] * x[i]
            + d * x[i] + e;
      Memo1.Lines.Add('     ans' + inttostr(i + 1) + '= ' + floatTostr(roundx(xans)));
    end;
    k := k * 2;
  end;
end;

Initialization
  // f
  Czero := VarComplex(0, 0);
end.
